/*******************************************************************************
 * Copyright (c) 2005, 2006 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: PerformanceExample.java,v 1.6 2006-11-13 20:17:32 samwai Exp $
 * 
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/
package org.eclipse.hyades.test.collection.framework;

import java.awt.Button;
import java.awt.FlowLayout;
import java.awt.Frame;
import java.awt.Panel;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

public class PerformanceExample extends Frame {

	/**
	 * 
	 */
	private static final long serialVersionUID = 6774691377468167623L;

	Panel panel = new Panel();

	Button buttons[] = new Button[20];

	int numButtons = 0;

	public PerformanceExample() {
		super("Performance Example");

		panel.setLayout(new FlowLayout());
		add("Center", panel);

		Panel btnPanel = new Panel();

		Button addBtn = new Button("Add");

		addBtn.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				addButton();
			}
		});

		btnPanel.add(addBtn);
		Button removeBtn = new Button("Remove");

		removeBtn.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				removeButton();
			}
		});

		btnPanel.add(removeBtn);
		add("North", btnPanel);

		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				System.exit(0);
			}
		});

	}

	public void addButton() {
		if (numButtons < buttons.length) {

			Button btn = new Button(String.valueOf(numButtons));
			System.out.println("add button : " + btn);
			buttons[numButtons++] = btn;
			panel.add(btn);
			panel.validate();
			panel.repaint();
		}

	}

	static public void main(String args[]) {
		Frame frame = new PerformanceExample();
		frame.setSize(300, 300);
		frame.setVisible(true);
	}

	public void removeButton() {
		if (numButtons > 0) {
			panel.remove(buttons[--numButtons]);
			System.out.println("remove button : " + numButtons);

			panel.validate();
			panel.repaint();
			System.gc();
		}

	}
}
