/**********************************************************************
 * Copyright (c) 2003, 2010 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: TRCObjectReference.java,v 1.10 2010-12-07 21:07:55 jcayne Exp $
 **********************************************************************/
 
/*
 * generated using TPTP customized JET templates
 */

package org.eclipse.hyades.models.trace;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>TRC Object Reference</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.trace.TRCObjectReference#getHeapDump <em>Heap Dump</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.trace.TRCObjectReference#getOwner <em>Owner</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.trace.TRCObjectReference#getTarget <em>Target</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCObjectReference()
 * @model
 * @generated
 */
public interface TRCObjectReference extends EObject {
	/**
	 * Returns the value of the '<em><b>Heap Dump</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link org.eclipse.hyades.models.trace.TRCHeapDump#getReferences <em>References</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Heap Dump</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Heap Dump</em>' container reference.
	 * @see #setHeapDump(TRCHeapDump)
	 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCObjectReference_HeapDump()
	 * @see org.eclipse.hyades.models.trace.TRCHeapDump#getReferences
	 * @model opposite="references" required="true"
	 * @generated
	 */
	TRCHeapDump getHeapDump();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.trace.TRCObjectReference#getHeapDump <em>Heap Dump</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Heap Dump</em>' container reference.
	 * @see #getHeapDump()
	 * @generated
	 */
	void setHeapDump(TRCHeapDump value);

	/**
	 * Returns the value of the '<em><b>Owner</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link org.eclipse.hyades.models.trace.TRCHeapObject#getRefOwner <em>Ref Owner</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Owner</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * transient
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Owner</em>' reference.
	 * @see #setOwner(TRCHeapObject)
	 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCObjectReference_Owner()
	 * @see org.eclipse.hyades.models.trace.TRCHeapObject#getRefOwner
	 * @model opposite="refOwner" resolveProxies="false" required="true"
	 * @generated
	 */
	TRCHeapObject getOwner();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.trace.TRCObjectReference#getOwner <em>Owner</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Owner</em>' reference.
	 * @see #getOwner()
	 * @generated
	 */
	void setOwner(TRCHeapObject value);

	/**
	 * Returns the value of the '<em><b>Target</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link org.eclipse.hyades.models.trace.TRCHeapObject#getRefTarget <em>Ref Target</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Target</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * transient
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Target</em>' reference.
	 * @see #setTarget(TRCHeapObject)
	 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCObjectReference_Target()
	 * @see org.eclipse.hyades.models.trace.TRCHeapObject#getRefTarget
	 * @model opposite="refTarget" resolveProxies="false" required="true"
	 * @generated
	 */
	TRCHeapObject getTarget();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.trace.TRCObjectReference#getTarget <em>Target</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Target</em>' reference.
	 * @see #getTarget()
	 * @generated
	 */
	void setTarget(TRCHeapObject value);

} // TRCObjectReference
