/**********************************************************************
 * Copyright (c) 2003, 2011 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: TRCThreadEvent.java,v 1.12 2009-05-05 15:49:16 paules Exp $
 **********************************************************************/
 
/*
 * generated using TPTP customized JET templates
 */

package org.eclipse.hyades.models.trace;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.hyades.models.hierarchy.TRCAnnotation;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>TRC Thread Event</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.trace.TRCThreadEvent#getTime <em>Time</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.trace.TRCThreadEvent#getTraceOrder <em>Trace Order</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.trace.TRCThreadEvent#getThread <em>Thread</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.trace.TRCThreadEvent#getAnnotations <em>Annotations</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCThreadEvent()
 * @model
 * @generated
 */
public interface TRCThreadEvent extends EObject {
	/**
	 * Returns the value of the '<em><b>Time</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Time</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Time</em>' attribute.
	 * @see #setTime(double)
	 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCThreadEvent_Time()
	 * @model
	 * @generated
	 */
	double getTime();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.trace.TRCThreadEvent#getTime <em>Time</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Time</em>' attribute.
	 * @see #getTime()
	 * @generated
	 */
	void setTime(double value);

	/**
	 * Returns the value of the '<em><b>Trace Order</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Trace Order</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Trace Order</em>' attribute.
	 * @see #setTraceOrder(long)
	 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCThreadEvent_TraceOrder()
	 * @model
	 * @generated
	 */
	long getTraceOrder();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.trace.TRCThreadEvent#getTraceOrder <em>Trace Order</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Trace Order</em>' attribute.
	 * @see #getTraceOrder()
	 * @generated
	 */
	void setTraceOrder(long value);

	/**
	 * Returns the value of the '<em><b>Thread</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link org.eclipse.hyades.models.trace.TRCThread#getThreadEvents <em>Thread Events</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Thread</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Thread</em>' container reference.
	 * @see #setThread(TRCThread)
	 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCThreadEvent_Thread()
	 * @see org.eclipse.hyades.models.trace.TRCThread#getThreadEvents
	 * @model opposite="threadEvents" required="true"
	 * @generated
	 */
	TRCThread getThread();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.trace.TRCThreadEvent#getThread <em>Thread</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Thread</em>' container reference.
	 * @see #getThread()
	 * @generated
	 */
	void setThread(TRCThread value);

	/**
	 * Returns the value of the '<em><b>Annotations</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.hyades.models.hierarchy.TRCAnnotation}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Annotations</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Annotations</em>' containment reference list.
	 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCThreadEvent_Annotations()
	 * @model containment="true"
	 * @generated
	 */
	EList<TRCAnnotation> getAnnotations();

} // TRCThreadEvent
