/**********************************************************************
 * Copyright (c) 2011 IBM Corporation
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: 
 * 
 * Contributors: 
 * IBM - Initial implementation
 **********************************************************************/

package org.eclipse.hyades.trace.ui;

import java.util.HashMap;
import java.util.Map;

import org.eclipse.hyades.models.hierarchy.TRCAgentProxy;

/** A generic mapper between agents and objects (with strings as key). */
public class UIPluginMap {

	private HashMap<TRCAgentProxy, Map<String, Object>> _properties = new HashMap<TRCAgentProxy, Map<String, Object>>();
	
	/** Get a generic property from the map for a particular agent*/
	public Object getProperty(TRCAgentProxy a, String s) {
		synchronized(_properties) {
			Map<String, Object> m = _properties.get(a);
			if(m == null) {
				m = new HashMap<String, Object>();
				_properties.put(a,  m);
			}
						
			return m.get(s);
		}
		
	}
	
	/** Set a generic property from the map for a particular agent*/
	public void setProperty(TRCAgentProxy a, String s, Object o) {  
		synchronized(_properties) {
			Map<String, Object> m = _properties.get(a);
			if(m == null) {
				m = new HashMap<String, Object>();
				_properties.put(a,  m);
			}
						
			m.put(s, o);
		}
	}
	
}
