/**********************************************************************
 * Copyright (c) 2005, 2012 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: OpenProcessWizard.java,v 1.10 2006-09-20 18:53:52 ewchan Exp $
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/

package org.eclipse.hyades.trace.ui.internal.wizard;

import java.util.Iterator;

import org.eclipse.hyades.models.hierarchy.TRCProcessProxy;
import org.eclipse.hyades.trace.internal.ui.PDPluginImages;
import org.eclipse.hyades.trace.internal.ui.PDProjectExplorer;
import org.eclipse.hyades.trace.ui.UIPlugin;
import org.eclipse.hyades.trace.ui.internal.util.TraceMessages;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.IWorkbench;

public class OpenProcessWizard extends NavigatorWizard  /* Ali M.: Extended Navigator wizard */
{
	protected PDProjectExplorer fViewer;

	protected IStructuredSelection fSelection;

	protected TRCProcessProxy fProcess;

	protected OpenProcessWizardPage fPage;

	public OpenProcessWizard() {
		setNeedsProgressMonitor(true);
	}

	public void addPages() {
		setWindowTitle(TraceMessages.PROP);
		fPage = new OpenProcessWizardPage("OpenProcessPage");
		addPage(fPage);
	}

	public TRCProcessProxy getProcess() {
		return fProcess;
	}

	@SuppressWarnings("rawtypes")
	public void init(IWorkbench workbench, IStructuredSelection selection) {
		fSelection = selection;
		if (selection instanceof IStructuredSelection) {
			Iterator enum1 = ((IStructuredSelection) selection).iterator();
			if (enum1.hasNext()) {
				Object cg = enum1.next();
				if (cg instanceof TRCProcessProxy) {
					fProcess = (TRCProcessProxy) cg;
				}
			}
		}

		setDefaultPageImageDescriptor(UIPlugin
				.getImageDescriptor(PDPluginImages.IMG_UI_WZ_PROC_PROP));
	}

	public boolean performFinish() {
		return fPage.finish();
	}

	public void setViewer(PDProjectExplorer viewer) {
		fViewer = viewer;
	}
}
