/* ***********************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: SVGGeneratorInvalidInputException.java,v 1.2 2005-06-10 14:03:15 dguilbaud Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 ************************************************************/

package org.eclipse.tptp.platform.report.chart.svg.internal;
/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: SVGGeneratorInvalidInputException.java,v 1.2 2005-06-10 14:03:15 dguilbaud Exp $
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/


/**
 * <code>SVGGeneratorInvalidInputException</code> is thrown by the SVG generator
 * if the input is invalid.  The input XML may be not well-formed or does not conform
 * to <code>input.xsd</code>.
 * @see SVGGeneratorException
 */
public class SVGGeneratorInvalidInputException extends SVGGeneratorException {

	/**
     * 
     */
    private static final long serialVersionUID = 1L;

    /**
	 * Constructs an SVGGeneratorException with no detailed message.
	 */
	public SVGGeneratorInvalidInputException() {
		super();
	}

	/**
	 * Constructs an SVGGeneratorException with a detailed message
	 * @param message the detail message. The detail message is saved for 
	 * later retrieval by the Throwable.getMessage() method.
	 */
	public SVGGeneratorInvalidInputException(String message) {
		super(message);
	}

	/**
	 * Constructs a new throwable with the specified cause and a detail 
	 * message of (cause==null ? null : cause.toString()) (which typically 
	 * contains the class and detail message of cause). 
	 * @param cause the cause
	 */
	public SVGGeneratorInvalidInputException(Throwable cause) {
		super(cause);
	}
}
