/* ***********************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: Configuration.java,v 1.1 2005-03-30 08:26:41 dguilbaud Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 ************************************************************/

/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: Configuration.java,v 1.1 2005-03-30 08:26:41 dguilbaud Exp $
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/

package org.eclipse.tptp.platform.report.chart.svg.internal.input;

import org.w3c.dom.Element;



/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Configuration</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.Configuration#getSize <em>Size</em>}</li>
 *   <li>{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.Configuration#getTitleBar <em>Title Bar</em>}</li>
 *   <li>{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.Configuration#getAxes <em>Axes</em>}</li>
 *   <li>{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.Configuration#getLegend <em>Legend</em>}</li>
 *   <li>{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.Configuration#getTimestamp <em>Timestamp</em>}</li>
 *   <li>{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.Configuration#getChartArea <em>Chart Area</em>}</li>
 *   <li>{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.Configuration#getPlotArea <em>Plot Area</em>}</li>
 *   <li>{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.Configuration#getShapes <em>Shapes</em>}</li>
 *   <li>{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.Configuration#getPalettes <em>Palettes</em>}</li>
 *   <li>{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.Configuration#getPreferences <em>Preferences</em>}</li>
 * </ul>
 * </p>
 *
 * @model 
 * @generated
 */
public interface Configuration {
	/**
	 * Returns the value of the '<em><b>Internationalization</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Internationalization</em>' containment reference.
	 * @see #setInternationalization(Internationalization)
	 * @see org.eclipse.tptp.platform.report.chart.svg.internal.input.InputPackage#getConfiguration_Internationalization()
	 * @model containment="true"
	 * @generated
	 */
	Internationalization getInternationalization();

	/**
	 * Sets the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.Configuration#getInternationalization <em>Internationalization</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Internationalization</em>' containment reference.
	 * @see #getInternationalization()
	 * @generated
	 */
	void setInternationalization(Internationalization value);

	/**
	 * Returns the value of the '<em><b>Size</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Size</em>' containment reference.
	 * @see #setSize(Size)
	 * @see org.eclipse.tptp.platform.report.chart.svg.internal.input.InputPackage#getConfiguration_Size()
	 * @model containment="true"
	 * @generated
	 */
	Size getSize();

	/**
	 * Sets the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.Configuration#getSize <em>Size</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Size</em>' containment reference.
	 * @see #getSize()
	 * @generated
	 */
	void setSize(Size value);

	/**
	 * Returns the value of the '<em><b>Title Bar</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Title Bar</em>' containment reference.
	 * @see #setTitleBar(TitleBar)
	 * @see org.eclipse.tptp.platform.report.chart.svg.internal.input.InputPackage#getConfiguration_TitleBar()
	 * @model containment="true"
	 * @generated
	 */
	TitleBar getTitleBar();

	/**
	 * Sets the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.Configuration#getTitleBar <em>Title Bar</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Title Bar</em>' containment reference.
	 * @see #getTitleBar()
	 * @generated
	 */
	void setTitleBar(TitleBar value);

	/**
	 * Returns the value of the '<em><b>DataValue</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>DataValue</em>' containment reference.
	 * @see #setDataValue(DataValue)
	 * @see org.eclipse.tptp.platform.report.chart.svg.internal.input.InputPackage#getConfiguration_DataValue()
	 * @model containment="true"
	 * @generated
	 */
	DataValue getDataValue();

	/**
	 * Sets the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.Configuration#getDataValue <em>DataValue</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>DataValue</em>' containment reference.
	 * @see #getDataValue()
	 * @generated
	 */
	void setDataValue(DataValue value);

	/**
	 * Returns the value of the '<em><b>Axes</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Axes</em>' containment reference.
	 * @see #setAxes(Axes)
	 * @see org.eclipse.tptp.platform.report.chart.svg.internal.input.InputPackage#getConfiguration_Axes()
	 * @model containment="true"
	 * @generated
	 */
	Axes getAxes();

	/**
	 * Sets the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.Configuration#getAxes <em>Axes</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Axes</em>' containment reference.
	 * @see #getAxes()
	 * @generated
	 */
	void setAxes(Axes value);

	/**
	 * Returns the value of the '<em><b>Legend</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Legend</em>' containment reference.
	 * @see #setLegend(Legend)
	 * @see org.eclipse.tptp.platform.report.chart.svg.internal.input.InputPackage#getConfiguration_Legend()
	 * @model containment="true"
	 * @generated
	 */
	Legend getLegend();

	/**
	 * Sets the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.Configuration#getLegend <em>Legend</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Legend</em>' containment reference.
	 * @see #getLegend()
	 * @generated
	 */
	void setLegend(Legend value);

	/**
	 * Returns the value of the '<em><b>Timestamp</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Timestamp</em>' containment reference.
	 * @see #setTimestamp(Timestamp)
	 * @see org.eclipse.tptp.platform.report.chart.svg.internal.input.InputPackage#getConfiguration_Timestamp()
	 * @model containment="true"
	 * @generated
	 */
	Timestamp getTimestamp();

	/**
	 * Sets the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.Configuration#getTimestamp <em>Timestamp</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Timestamp</em>' containment reference.
	 * @see #getTimestamp()
	 * @generated
	 */
	void setTimestamp(Timestamp value);

	/**
	 * Returns the value of the '<em><b>Chart Area</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Chart Area</em>' containment reference.
	 * @see #setChartArea(ChartArea)
	 * @see org.eclipse.tptp.platform.report.chart.svg.internal.input.InputPackage#getConfiguration_ChartArea()
	 * @model containment="true"
	 * @generated
	 */
	ChartArea getChartArea();

	/**
	 * Sets the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.Configuration#getChartArea <em>Chart Area</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Chart Area</em>' containment reference.
	 * @see #getChartArea()
	 * @generated
	 */
	void setChartArea(ChartArea value);

	/**
	 * Returns the value of the '<em><b>Plot Area</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Plot Area</em>' containment reference.
	 * @see #setPlotArea(PlotArea)
	 * @see org.eclipse.tptp.platform.report.chart.svg.internal.input.InputPackage#getConfiguration_PlotArea()
	 * @model containment="true"
	 * @generated
	 */
	PlotArea getPlotArea();

	/**
	 * Sets the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.Configuration#getPlotArea <em>Plot Area</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Plot Area</em>' containment reference.
	 * @see #getPlotArea()
	 * @generated
	 */
	void setPlotArea(PlotArea value);

	/**
	 * Returns the value of the '<em><b>Shapes</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Shapes</em>' containment reference.
	 * @see #setShapes(Shapes)
	 * @see org.eclipse.tptp.platform.report.chart.svg.internal.input.InputPackage#getConfiguration_Shapes()
	 * @model containment="true"
	 * @generated
	 */
	Shapes getShapes();

	/**
	 * Sets the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.Configuration#getShapes <em>Shapes</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Shapes</em>' containment reference.
	 * @see #getShapes()
	 * @generated
	 */
	void setShapes(Shapes value);

	/**
	 * Returns the value of the '<em><b>Palettes</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Palettes</em>' containment reference.
	 * @see #setPalettes(Palettes)
	 * @see org.eclipse.tptp.platform.report.chart.svg.internal.input.InputPackage#getConfiguration_Palettes()
	 * @model containment="true"
	 * @generated
	 */
	Palettes getPalettes();

	/**
	 * Sets the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.Configuration#getPalettes <em>Palettes</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Palettes</em>' containment reference.
	 * @see #getPalettes()
	 * @generated
	 */
	void setPalettes(Palettes value);

	/**
	 * Returns the value of the '<em><b>Preferences</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Preferences</em>' containment reference.
	 * @see #setPreferences(Preferences)
	 * @see org.eclipse.tptp.platform.report.chart.svg.internal.input.InputPackage#getConfiguration_Preferences()
	 * @model containment="true"
	 * @generated
	 */
	Preferences getPreferences();

	/**
	 * Sets the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.Configuration#getPreferences <em>Preferences</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Preferences</em>' containment reference.
	 * @see #getPreferences()
	 * @generated
	 */
	void setPreferences(Preferences value);

	/**
	 * Returns the value of the '<em><b>Scripts</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Scripts</em>' containment reference.
	 * @see #setScripts(Scripts)
	 * @see org.eclipse.tptp.platform.report.chart.svg.internal.input.InputPackage#getConfiguration_Scripts()
	 * @model containment="true"
	 * @generated
	 */
	Scripts getScripts();

	/**
	 * Sets the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.Configuration#getScripts <em>Scripts</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Scripts</em>' containment reference.
	 * @see #getScripts()
	 * @generated
	 */
	void setScripts(Scripts value);

	/**
	 * Returns the document object element of this object. 
	 * If this object was not initialized with an element, null will be returned.
	 * @return the element in the DOM represented by this object
	 */
	public Element getElement(); 

} // Configuration
