/* ***********************************************************
 * Copyright (c) 2005, 2008 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: DCategory.java,v 1.2 2008-05-23 14:11:47 jcayne Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 ************************************************************/


package org.eclipse.tptp.platform.report.core.internal;

/**
 * This class allows to create categories on a DAxis object
 * A DCoord object can have a DCategory id as value
 * @see DAxis
 * @see DCategory
 * This extension is only available for SVG generation
 * 
 * @deprecated As of TPTP 4.5.0, use the TPTP Business Intelligence and Reporting Tools (BIRT) reporting infrastructure (<code>org.eclipse.tptp.platform.report.birt</code>).
 *  
 */
public class DCategory extends DItemContainer 
{
    
    private String id;
    private String label;
    private String tooltip;
   
    /** @return category ID */
    public String getId() {
        return id;
    }
    
    /** Sets the id */
    public void setId(String id) {
        this.id = id;
    }
    
    /** @return the label */
    public String getLabel() {
        return label;
    }
    
    /** Sets the label */
    public void setLabel(String label) {
        this.label = label;
    }
   
    /** @return the tooltip text */
    public String getTooltip() {
        return tooltip;
    }
    
    /** Sets the tooltip text */
    public void setTooltip(String tooltip) {
        this.tooltip = tooltip;
    }
}
