/* ***********************************************************
 * Copyright (c) 2005, 2008 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: IVObject.java,v 1.2 2008-05-23 14:11:53 jcayne Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 ************************************************************/


/*
 * Created on 10 dc. 2003
 *
 */
package org.eclipse.tptp.platform.report.tools.internal;

/**
 * Interface for a set/get using Object.
 * @see IDisposable
 * @deprecated As of TPTP 4.5.0, use the TPTP Business Intelligence and Reporting Tools (BIRT) reporting infrastructure (<code>org.eclipse.tptp.platform.report.birt</code>).
 */
public interface IVObject
{
  /** @return current stored object */
  public Object getObject();
  
  /**
   * Change the current value of stored object.
   * To handle correclty stored system resource such as Font,Color that MUST be disposed.
   * this is under the responsability of IVObject implementor to check before changing current value,
   * this value isn't an instance of IDisposable and if it's the case to call .dispose() method.
   */
  public void setObject( Object object );
}
